<?php
/**
 * Components_Release_Task_TagRelease:: tags the git repository.
 *
 * PHP version 5
 *
 * @category Horde
 * @package  Components
 * @author   Gunnar Wrobel <wrobel@pardus.de>
 * @license  http://www.horde.org/licenses/lgpl21 LGPL 2.1
 * @link     http://pear.horde.org/index.php?package=Components
 */

/**
 * Components_Release_Task_TagRelease:: tags the git repository.
 *
 * Copyright 2011-2016 Horde LLC (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (LGPL). If you
 * did not receive this file, see http://www.horde.org/licenses/lgpl21.
 *
 * @category Horde
 * @package  Components
 * @author   Gunnar Wrobel <wrobel@pardus.de>
 * @license  http://www.horde.org/licenses/lgpl21 LGPL 2.1
 * @link     http://pear.horde.org/index.php?package=Components
 */
class Components_Release_Task_TagRelease
extends Components_Release_Task_Base
{
    /**
     * Run the task.
     *
     * @param array &$options Additional options.
     *
     * @return NULL
     */
    public function run(&$options)
    {
        $release = $this->getComponent()->getName() 
            . '-' . $this->getComponent()->getVersion();
        $this->getComponent()->tag(
            strtolower($release),
            'Released ' . $release . '.',
            new Components_Helper_Commit(
                $this->getOutput(),
                $options
            )
        );
    }
}